#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <dhudmessage>

//#define USE_MONEY_UL

#if defined USE_MONEY_UL
#include <money_ul>
#endif

#define PLUGIN "Mind Games"
#define VERSION "1.0" 
#define AUTHOR "fifayer"

#define TASK_QUEST_HUD		333000
#define DHUD_INFO_ALIVE		120, 120, 120, 0.02, 0.92, 0, 0.0, 4.2, 0.0, 0.0
#define DHUD_INFO_DEAD		200, 200, 200, 0.02, 0.92, 0, 0.0, 4.2, 0.0, 0.0
#define DHUD_AWARD			100, 100, 100, 0.02, 0.65, 0, 0.0, 2.5, 0.0, 0.5

new bool:g_bQuestAlive, g_strQuestion[40], g_iAnswer;

new	g_pAdminLevel,
	g_pRandomAward,
	g_pDefaultAward,
	g_pLowerLimit,
	g_pUpperLimit;

public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_dictionary("MindGames.txt")
	
	register_cvar( "mind_games_version", VERSION, FCVAR_SERVER )
	set_cvar_string("mind_games_version", VERSION )
	
	g_pAdminLevel = 	register_cvar ( "mg_admin_level"	,	"j" )
	g_pRandomAward = 	register_cvar ( "mg_random_award"	, 	"0" )
	g_pDefaultAward = 	register_cvar ( "mg_default_award"	, 	"4000" )
	g_pLowerLimit = 	register_cvar ( "mg_lover_limit"	, 	"1000" )
	g_pUpperLimit = 	register_cvar ( "mg_upper_limit"	, 	"8000" )
	
	register_clcmd("say","ClCmd_CheckAnswer");
	register_clcmd("say_team","ClCmd_CheckAnswer");
	
	register_clcmd("amx_start_quest","ClCmd_StartQuest", 0, "- starts quest." )
	
	set_task(120.0, "AutoStartQuest", _, _, _, "b")
}

public plugin_precache() 
{
	precache_sound("mind_games/off.wav")
	precache_sound("buttons/bell1.wav")
	return PLUGIN_CONTINUE
}

public ClCmd_StartQuest( id, lvl, cid )
{
	new m_strLvl[22];
	get_pcvar_string(g_pAdminLevel,m_strLvl,charsmax(m_strLvl));
	
	if( !cmd_access( id, read_flags(m_strLvl), cid, 0 ) )
		return PLUGIN_HANDLED

	if (!g_bQuestAlive) {
		StartQuest();
		new m_strName[32];
		get_user_name(id,m_strName,charsmax(m_strName));
		client_print(0,print_chat,"%L",LANG_PLAYER,"MG_ADMIN_STARTED",m_strName);	
	}
	else {
		#if defined AMXMOD_BCOMPAT
		console_print(id, SIMPLE_T("Quest is already started!"));
		#else
		console_print(id,"%L",id,"MG_STARTED");
		#endif
	}
		
	return PLUGIN_HANDLED;
}

public AutoStartQuest()
{
	if (task_exists(TASK_QUEST_HUD,0))
	{
		remove_task(TASK_QUEST_HUD);
		set_task(4.0,"StartQuest")
	}
	else	StartQuest()
}

public StartQuest()
{
	g_bQuestAlive=true;
	
	new num[5], num2[5],i;
	
	for (i=0; i <= 4; i++)
		num[i] = random_num(0, 50)
	for (i=0; i <= 4; i++)
		num2[i] = random_num(1,5)
		
	new m_iPart = random_num(1,4),
		m_iType = random_num(1, m_iPart == 4 ? 3:4)
	
	switch(m_iPart)
	{
		case 1:
		{
			switch(m_iType)
			{
				case 1:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i + %i + %i", num[0], num[1], num[2])
					g_iAnswer = num[0] + num[1] + num[2];
				}
				case 2:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i - %i - %i", num[0], num[1], num[2])
					g_iAnswer = num[0] - num[1] - num[2];
				}
				case 3:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i + %i - %i", num[0], num[1], num[2])
					g_iAnswer = num[0] + num[1] - num[2];
				}
				case 4:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i + %i * %i", num[0], num2[1], num2[0])
					g_iAnswer = num[0] + num2[1] * num2[0];
				}
				case 5:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i * %i * %i", num2[0], num2[1], num2[2])
					g_iAnswer = num2[0] * num2[1] * num2[2];
				}
			}
		}
		
		case 2:
		{
			switch(m_iType)
			{
				case 1:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i + %i + %i + %i", num[0], num[1], num[2], num[3])
					g_iAnswer = num[0] + num[1] + num[2] + num[3];
				}
				case 2:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i - %i - %i - %i", num[0], num[1], num[2], num[3])
					g_iAnswer = num[0] - num[1] - num[2]  - num[3];
				}
				case 3:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i + %i - %i + %i", num[0], num[1], num[2], num[3])
					g_iAnswer = num[0] + num[1] - num[2] + num[3];
				}
				case 4:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i + %i + %i * %i", num[0], num[1], num2[2], num2[0])
					g_iAnswer = num[0] + num[1] + num2[2] * num2[0];
				}
				case 5:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i * %i * %i * %i", num2[0], num2[1], num2[2] , num2[3])
					g_iAnswer = num2[0] * num2[1] * num2[2] * num2[3]
				}
			}
		}
		
		case 3:
		{
			switch(m_iType)
			{
				case 1:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i + %i + %i + %i + %i", num[0], num[1], num[2], num[3], num[4])
					g_iAnswer = num[0] + num[1] + num[2] + num[3] + num[4];
				}
				case 2:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i - %i - %i - %i - %i", num[0], num[1], num[2], num[3], num[4])
					g_iAnswer = num[0] - num[1] - num[2] - num[3] - num[4];
				}
				case 3:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i + %i - %i + %i - %i", num[0], num[1], num[2], num[3], num[4])
					g_iAnswer = num[0] + num[1] - num[2] + num[3] - num[4];
				}
				case 4:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i + %i + %i * %i + %i", num[0], num[1], num2[0], num2[1], num[3])
					g_iAnswer = num[0] + num[1] + num2[0] * num2[1] + num[3];
				}
				case 5:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i * %i * %i * %i / %i", num2[0], num2[1], num2[2] , num2[3], num2[1])
					g_iAnswer = num2[0] * num2[1] * num2[2] * num2[3] / num2[1];
				}
			}
		}
		case 4:
		{
			switch(m_iType)
			{
				case 1:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"( %i + %i ) * ( %i + %i )", num2[0], num2[1], num2[2], num2[3])
					g_iAnswer = (num2[0] + num2[1]) * (num2[2] + num2[3])
				}
				case 2:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"%i * %i - %i * %i", num[0], num2[0], num[1], num2[1])
					g_iAnswer = num[0]*num2[0]-num[1]*num2[1]
				}
				case 3:
				{
					formatex( g_strQuestion, charsmax( g_strQuestion ),"( %i + %i + %i ) * %i", num2[0], num2[1], num2[3], num2[4])
					g_iAnswer = (num2[0]+num2[1]+num2[3]) * num2[4]
				}
			}
		}
	}
	
	QuestHUD()
	set_task(4.0, "QuestHUD", TASK_QUEST_HUD, _, 0, "b")
	client_cmd(0, "spk buttons/bell1" )
	return PLUGIN_HANDLED;
}

public QuestHUD()
{
	if (g_bQuestAlive)
	{	
		new Players[32],playerCount, i, id;
		get_players(Players, playerCount, "ch") 
		for (i=0; i<playerCount; i++) 
		{
			id = Players[i] 
			if (is_user_alive(id))
				set_dhudmessage(DHUD_INFO_ALIVE)
			else
				set_dhudmessage(DHUD_INFO_DEAD)
				
			show_dhudmessage(id, "%s = ?", g_strQuestion)
		}
	}
	else
	{
		remove_task(TASK_QUEST_HUD);
	}
	return PLUGIN_HANDLED;
}

public ClCmd_CheckAnswer(id)
{
	if ( g_bQuestAlive ) 
	{
		static m_strText[12], m_strAnswer[12];

		read_args(m_strText, charsmax(m_strText))
		remove_quotes(m_strText);
		
		num_to_str(g_iAnswer, m_strAnswer, charsmax(m_strAnswer))
	
		if (equali(m_strText, m_strAnswer )) {
			AwardPlayer(id);
		}
	} 
}

public AwardPlayer(id)
{
	if (!is_user_connected(id) || !(CS_TEAM_UNASSIGNED < cs_get_user_team(id) < CS_TEAM_SPECTATOR) || !g_bQuestAlive)
		return;	
		
	g_bQuestAlive = false;
		
	client_cmd(0, "spk mind_games/off" )
	
	new m_strWinner[32],
		m_iAward;
	
	get_user_name(id, m_strWinner, charsmax(m_strWinner))
	m_iAward = get_pcvar_num(g_pRandomAward) == 1 ? (random_num(get_pcvar_num(g_pLowerLimit),g_pUpperLimit)):get_pcvar_num(g_pDefaultAward);
	
	#if defined USE_MONEY_UL
	cs_set_user_money_ul(id, cs_get_user_money_ul(id) + m_iAward)
	#else
	cs_set_user_money(id, cs_get_user_money(id) + m_iAward)
	#endif
		
	new Players[32],playerCount ;
	get_players(Players, playerCount, "ch") 
	for (new i=0; i<playerCount; i++) 
	{
		set_dhudmessage(DHUD_AWARD);
		show_dhudmessage(Players[i] , "%L: %s^n%L: %i^n%L: %i", LANG_PLAYER, "MG_WINNER", m_strWinner, LANG_PLAYER, "MG_AWARD",m_iAward, LANG_PLAYER, "MG_ANSWER", g_iAnswer);
	}
	return;
}